function _aws_cdk_aws_scheduler_targets_alpha_CodeBuildStartBuild(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_CodePipelineStartPipelineExecution(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_EventBridgePutEventsEntry(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("detail" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EventBridgePutEventsEntry#detail", "");
        if ("detailType" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EventBridgePutEventsEntry#detailType", "");
        if ("eventBus" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EventBridgePutEventsEntry#eventBus", "");
        if ("source" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EventBridgePutEventsEntry#source", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_EventBridgePutEvents(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_Tag(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("key" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.Tag#key", "");
        if ("value" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.Tag#value", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_EcsRunTaskBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("taskDefinition" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskDefinition", "");
        if ("capacityProviderStrategies" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#capacityProviderStrategies", "");
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ecs_CapacityProviderStrategy(o);
        if ("enableEcsManagedTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableEcsManagedTags", "");
        if ("enableExecuteCommand" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableExecuteCommand", "");
        if ("group" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#group", "");
        if ("propagateTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#propagateTags", "");
        if ("referenceId" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#referenceId", "");
        if ("securityGroups" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#securityGroups", "");
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ec2_ISecurityGroup(o);
        if ("tags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#tags", "");
        if (p.tags != null)
            for (const o of p.tags)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_scheduler_targets_alpha_Tag(o);
        if ("taskCount" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskCount", "");
        if ("vpcSubnets" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#vpcSubnets", "");
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_FargateTaskProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("assignPublicIp" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.FargateTaskProps#assignPublicIp", "");
        if ("platformVersion" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.FargateTaskProps#platformVersion", "");
        if ("taskDefinition" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskDefinition", "");
        if ("capacityProviderStrategies" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#capacityProviderStrategies", "");
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ecs_CapacityProviderStrategy(o);
        if ("enableEcsManagedTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableEcsManagedTags", "");
        if ("enableExecuteCommand" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableExecuteCommand", "");
        if ("group" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#group", "");
        if ("propagateTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#propagateTags", "");
        if ("referenceId" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#referenceId", "");
        if ("securityGroups" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#securityGroups", "");
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ec2_ISecurityGroup(o);
        if ("tags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#tags", "");
        if (p.tags != null)
            for (const o of p.tags)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_scheduler_targets_alpha_Tag(o);
        if ("taskCount" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskCount", "");
        if ("vpcSubnets" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#vpcSubnets", "");
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_Ec2TaskProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("placementConstraints" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.Ec2TaskProps#placementConstraints", "");
        if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ecs_PlacementConstraint(o);
        if ("placementStrategies" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.Ec2TaskProps#placementStrategies", "");
        if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ecs_PlacementStrategy(o);
        if ("taskDefinition" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskDefinition", "");
        if ("capacityProviderStrategies" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#capacityProviderStrategies", "");
        if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ecs_CapacityProviderStrategy(o);
        if ("enableEcsManagedTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableEcsManagedTags", "");
        if ("enableExecuteCommand" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#enableExecuteCommand", "");
        if ("group" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#group", "");
        if ("propagateTags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#propagateTags", "");
        if ("referenceId" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#referenceId", "");
        if ("securityGroups" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#securityGroups", "");
        if (p.securityGroups != null)
            for (const o of p.securityGroups)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_ec2_ISecurityGroup(o);
        if ("tags" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#tags", "");
        if (p.tags != null)
            for (const o of p.tags)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_scheduler_targets_alpha_Tag(o);
        if ("taskCount" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#taskCount", "");
        if ("vpcSubnets" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.EcsRunTaskBaseProps#vpcSubnets", "");
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_EcsRunTask(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_EcsRunFargateTask(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_EcsRunEc2Task(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_InspectorStartAssessmentRun(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_FirehosePutRecord(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_KinesisStreamPutRecordProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("partitionKey" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.KinesisStreamPutRecordProps#partitionKey", "");
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_KinesisStreamPutRecord(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_LambdaInvoke(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_SageMakerPipelineParameter(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("name" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.SageMakerPipelineParameter#name", "");
        if ("value" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.SageMakerPipelineParameter#value", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_SageMakerStartPipelineExecutionProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("pipelineParameterList" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.SageMakerStartPipelineExecutionProps#pipelineParameterList", "");
        if (p.pipelineParameterList != null)
            for (const o of p.pipelineParameterList)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_scheduler_targets_alpha_SageMakerPipelineParameter(o);
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_SageMakerStartPipelineExecution(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_SnsPublish(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_SqsSendMessageProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("messageGroupId" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.SqsSendMessageProps#messageGroupId", "");
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_SqsSendMessage(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_StepFunctionsStartExecution(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_ScheduleTargetBaseProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_ScheduleTargetBase(p) {
}
function _aws_cdk_aws_scheduler_targets_alpha_UniversalTargetProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if ("action" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.UniversalTargetProps#action", "");
        if ("service" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.UniversalTargetProps#service", "");
        if ("policyStatements" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.UniversalTargetProps#policyStatements", "");
        if (p.policyStatements != null)
            for (const o of p.policyStatements)
                if (!visitedObjects.has(o))
                    require("aws-cdk-lib/.warnings.jsii.js").aws_cdk_lib_aws_iam_PolicyStatement(o);
        if ("deadLetterQueue" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#deadLetterQueue", "");
        if ("input" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#input", "");
        if ("maxEventAge" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#maxEventAge", "");
        if ("retryAttempts" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#retryAttempts", "");
        if ("role" in p)
            print("@aws-cdk/aws-scheduler-targets-alpha.ScheduleTargetBaseProps#role", "");
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_scheduler_targets_alpha_Universal(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_scheduler_targets_alpha_CodeBuildStartBuild, _aws_cdk_aws_scheduler_targets_alpha_CodePipelineStartPipelineExecution, _aws_cdk_aws_scheduler_targets_alpha_EventBridgePutEventsEntry, _aws_cdk_aws_scheduler_targets_alpha_EventBridgePutEvents, _aws_cdk_aws_scheduler_targets_alpha_Tag, _aws_cdk_aws_scheduler_targets_alpha_EcsRunTaskBaseProps, _aws_cdk_aws_scheduler_targets_alpha_FargateTaskProps, _aws_cdk_aws_scheduler_targets_alpha_Ec2TaskProps, _aws_cdk_aws_scheduler_targets_alpha_EcsRunTask, _aws_cdk_aws_scheduler_targets_alpha_EcsRunFargateTask, _aws_cdk_aws_scheduler_targets_alpha_EcsRunEc2Task, _aws_cdk_aws_scheduler_targets_alpha_InspectorStartAssessmentRun, _aws_cdk_aws_scheduler_targets_alpha_FirehosePutRecord, _aws_cdk_aws_scheduler_targets_alpha_KinesisStreamPutRecordProps, _aws_cdk_aws_scheduler_targets_alpha_KinesisStreamPutRecord, _aws_cdk_aws_scheduler_targets_alpha_LambdaInvoke, _aws_cdk_aws_scheduler_targets_alpha_SageMakerPipelineParameter, _aws_cdk_aws_scheduler_targets_alpha_SageMakerStartPipelineExecutionProps, _aws_cdk_aws_scheduler_targets_alpha_SageMakerStartPipelineExecution, _aws_cdk_aws_scheduler_targets_alpha_SnsPublish, _aws_cdk_aws_scheduler_targets_alpha_SqsSendMessageProps, _aws_cdk_aws_scheduler_targets_alpha_SqsSendMessage, _aws_cdk_aws_scheduler_targets_alpha_StepFunctionsStartExecution, _aws_cdk_aws_scheduler_targets_alpha_ScheduleTargetBaseProps, _aws_cdk_aws_scheduler_targets_alpha_ScheduleTargetBase, _aws_cdk_aws_scheduler_targets_alpha_UniversalTargetProps, _aws_cdk_aws_scheduler_targets_alpha_Universal };
